#!/bin/sh

## 063g search path changed - variables changed - simplified path check code
TMP=~/.config/pmcputemp
arch=`uname -m`
load_module_func() {
	lsmod|grep -q coretemp
	CT=$?
	lsmod|grep -q k*temp
	KT=$?
	lsmod|grep -q it87
	IT=$?
	lsmod|grep -q lm85
	LT=$?
	lsmod|grep -q nct6775
	NT=$?
	lsmod|grep -q smsc47b397
	ST=$?
	if [ "$CT" = "1" ] && [ "$KT" = "1" ] && [ "$IT" = "1" ] && [ "$LT" = "1" ] && [ "$NT" = "1" ] && [ "$ST" = "1" ];then
		for m in coretemp k10temp k8temp it87 lm85 nct6775 smsc47b397
		do modprobe $m 2>/dev/null
			if [ "$?" = "0" ];then
				echo "loading $m"
				L=0
				break 
			else 
				L=1
				continue
			fi
		done
	[ "$L" = "1" ] && echo "Can't load a temperature module" && return 1
	fi
HD="/sys/class/hwmon/hwmon"
  for a in {0..7}
    do
      if ( cat $HD$a/temp0_label | grep "Core" ) || ( cat $HD$a/temp1_label | grep "Core" ) || ( cat $HD$a/temp2_label | grep "Core" ) || ( cat $HD$a/temp3_label | grep "Core" );then
	  HF=$HD$a
	  break
      fi
    done
  if [ "$HF" = "$HD" ];then echo "No valid path" && return 1
  fi
  return 0
}

cputempfunc() {
	if [ "${arch:0:3}" != "arm" ];then
		load_module_func
		[ $? -ne 0 ] && exit 1
	fi
	[ ! -d $TMP ] && mkdir $TMP
	FILE=""
     for b in {0..3}
       do
         if ( cat $HF"/temp"$b"_label" | grep "Core" );then
 	     FILE=$HF"/temp"$b"_input"
	     break
	    fi
	  done	
	if [ -z "$FILE" ];then echo "Failed to find file" && exit 1
	fi
	echo "${FILE} is written to $TMP"
	echo -n ${FILE} > $TMP/pmcputemprc
}
cputempfunc
